#!/bin/bash

kill_children()
{
	ppid=$1
	AllProcesses=`ps|grep [0-9]|awk '{print $1}'`

	for pid in $AllProcesses
	do
    		if [ -d "/proc/""$pid" ]; then
			cur_ppid=`cat "/proc/""$pid""/status"|grep PPid|awk '{print $2}'`
			if [ "$cur_ppid" -eq "$ppid" ]; then
	    			kill $pid 2> /dev/null
			fi
    		fi
	done	
}

	MainCmd=$1
	EscapeCmd=$2
	ExitWithEscapeStatus=27

    	{ $MainCmd; echo $? > maincmd_exit_status ;}&
    	pid_to_stop=$!
	
	is_there_such_process=`ps|awk '{print $1}'|grep $pid_to_stop`
    
	while ! [ -z "$is_there_such_process" ]
	do
		old_tty_setting=$(stty -g)
       		stty -icanon min 0 time 0 -echo
		#read one pressed key from terminal
		read -t 1 key
       		stty "$old_tty_setting"
    
		#check if the key is Esc
		char=`echo 27|awk '{printf("%c",$1)}'`
		#kill all descendant processes
		if [ "$key" = "$char" ]; then
			kill_children $pid_to_stop
			if [ -z "$EscapeCmd" ]; then
				[ -e maincmd_exit_status ] && rm maincmd_exit_status
				exit $ExitWithEscapeStatus
			else
				exec $EscapeCmd
			fi
		fi
	 	is_there_such_process=`ps|awk '{print $1}'|grep $pid_to_stop`   
    		done

	#get the exit status of wget if there is such
    	if [ -e maincmd_exit_status ]; then
		read -t 1 ExitStatus < maincmd_exit_status
        	rm maincmd_exit_status
    	fi
		
    	exit $ExitStatus