#!/bin/bash

	declare -r OldMenu="/mnt/menu.lst"
	declare -r NewMenu="/mnt/menu.lc"
	declare -r platformXML="/mnt/platform.xml"

	echo "Starting mastering..."

	. /mnt/parsexml.sh

	echo "0" > /proc/splash
	clear
	# check if platform.xml exists and parse it 
	if [ -f "$platformXML" ]; then
		parse "$platformXML"
		#grab OS
		i=0
		while ! [ "${xmlSTAT[i]}" = "<" -a "${xmlDATA[i]}" = "kit" ] && [ "$i" -lt "$xINDEX" ]
		do
			let "i++"
		done
		while [ "${xmlSTAT[i]}" != "os" -a "$i" -le "$xINDEX" ]
		do
			let "i++"
		done
		if [ "$i" -lt "$xINDEX" ]; then
			OS=${xmlDATA[i]}
		else
			echo "Warning: no OS name in $platrofmXML."
			exit 1
		fi

		OS=${OS%%' '*}
		case "$OS" in
			"Linux"	)
				/mnt/master.lx
				;;
			"WinCE"	)
				/mnt/master.ce
				;;
			"WinXPe"	)
				/mnt/master.xp
				;;
		esac

		if [ "$?" -eq 0 ]; then 
			cp "$NewMenu" "$OldMenu"
			echo -e "\tDevice is ready for making master image."
			sleep 3
			reboot
		else
			echo "Error occures while preparing the device for mastering. Reboot in 3 seconds..."
			sleep 3
			reboot
		fi
	else
		echo "There is no $platformXML. The device is not ready for mastering."
		sleep 3
		reboot
	fi
