#!/bin/bash	

	declare -a xmlSTAT				# contains the status informer
	declare -a xmlDATA				# contains any relevant data (element/attributes name/values and unparsed data)
	declare -i xINDEX=0				# global xINDEX pointer for xml**** arrays
	declare -i checkpoint=0				# a character counter & pointer for parserLINE
	declare -i doall=0				# a simple counter variable

	declare -r startTAG='<'			# literal <
	declare -r closeTAG='>'			# literal >
	declare -r slashTAG='/'			# literal /
	declare -r equalTAG='='			# literal =
	declare -r quoteTAG='"'			# literal "
	declare -r whiteTAG=' '			# literal
	declare -r tableTAG='	'		# literal
	declare elmentATTN=""			# element attribute name
	declare elmentATTV=""			# element attribute value
	declare elmentNAME=""			# element name value
	declare elmentDUMP=""			# element name dump
	
	declare parserLINE=""			# contains a single line read from the XML document sent to the parser
	declare parserFLAG="ENABLED"		# can have two mutually exclusive values: ENABLED / DISABLD
	declare parserFILE=""			# file sent to the parser
	declare parserBUFF=""			# parser buffer variable
	

	parse()
	{
		while read parserLINE
		do
			parserBUFF=""
			for ((checkpoint=0; checkpoint < ${#parserLINE}; checkpoint++)) ;
			do
				case "${parserLINE:$checkpoint:1}" in
				$startTAG)
					let "checkpoint++"; elmentNAME=""; parserFLAG="ENABLED"
					if [ "$parserBUFF" != '' ] ; then
							xmlSTAT[xINDEX]="#"
							xmlDATA[xINDEX]="$parserBUFF"
							let "xINDEX++"
							parserBUFF=""
					fi
					until [ "${parserLINE:$checkpoint:1}" = ' ' ] || \
					  	[ "${parserLINE:$checkpoint:1}" = '>' ] || \
					  	[ "$checkpoint" = "${#parserLINE}" ];
					do
						elmentNAME=$elmentNAME${parserLINE:$checkpoint:1}
						let "checkpoint++"
					done
					if [ "${elmentNAME:0:1}" = "$slashTAG" ] ; then
						xmlDATA[xINDEX]="${elmentNAME#*/}"
						xmlSTAT[xINDEX]="$closeTAG"
						let "xINDEX++"
						parserBUFF=""
					else
						xmlDATA[xINDEX]="$elmentNAME"
						xmlSTAT[xINDEX]="$startTAG"
						let "xINDEX++"; parserBUFF=""
						case "${parserLINE:$checkpoint:1}" in
							$whiteTAG)	elmentDUMP="$elmentNAME" ;;
							'')			elmentDUMP="$elmentNAME" ;;
						esac
					fi
				;;
				$slashTAG)
					case "$parserFLAG" in
					ENABLED)
						if [ "${parserLINE:$((checkpoint + 1)):1}" = "$closeTAG" ] ; then
							xmlSTAT[xINDEX]="$closeTAG"
							xmlDATA[xINDEX]="$elmentDUMP"
							let "xINDEX++"
							elmentDUMP=""; parserBUFF=""; let "checkpoint+=2"
						fi
					;;#	 	mount -t vfat "/dev/hda2" "/tmp/$mnt_dir"
					DISABLD)
					;;
					esac
				;;
				$quoteTAG)
					case $parserFLAG in
						ENABLED)
							let "checkpoint++"; elmentATTV=""; parserBUFF=""
							until [ "${parserLINE:$checkpoint:1}" = '"' ] ;
								do
									elmentATTV=$elmentATTV${parserLINE:$checkpoint:1}
									let "checkpoint++"
								done
							let "checkpoint++"; xmlDATA[xINDEX]="$elmentATTV"; let "xINDEX++"
							case "${parserLINE:$checkpoint:1}" in
								$closeTAG) if [ "${parserLINE:$((checkpoint + 1)):1}" = '<' ] ; then let "checkpoint-=1"; fi ;;
								$slashTAG) let "checkpoint-=1" ;;
							esac
						;;
						DISABLD)
						;;
					esac		
				;;
				$equalTAG)
					case "$parserFLAG" in
						ENABLED)
							elmentATTN=""
							if [ "${parserLINE:$((checkpoint + 1)):1}" = '"' ] ; then
								elmentATTN=${parserBUFF##$equalTAG}
								elmentATTN=${elmentATTN##*$whiteTAG}
								elmentATTN=${elmentATTN##*$tableTAG}  # my correction
								xmlSTAT[xINDEX]="$elmentATTN"
							fi
						;;
						DISABLD)
						;;
					esac
				;;
				esac
			
				case "$((checkpoint + 1))" in
					${#parserLINE})
						parserBUFF=$parserBUFF${parserLINE:$checkpoint:1}
						if [ "${parserLINE:$checkpoint:1}" != "$closeTAG" ] ; then
							xmlSTAT[xINDEX]="#"
							xmlDATA[xINDEX]="$parserBUFF"
							let "xINDEX++"
						fi
						;;
						*)
							case "${parserLINE:$checkpoint:1}" in
								$closeTAG)	parserBUFF=""; parserFLAG="DISABLD";;
								$startTAG)	let "checkpoint--";;
								*)			parserBUFF=$parserBUFF${parserLINE:$checkpoint:1};;
							esac
						;;
				esac
			done
		
		done < "$1"
	}