#!/bin/bash
	if [ "$UID" -ne 0 ]
	then
  		echo "Only root can run this script."
		sleep 5
  		reboot
	fi

	declare -r platformXML="/mnt/platform.xml"

	Platform=$1
	OS=$2
	Vendor=$3
	Model=$4


	touch "$platformXML"
	echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" > "$platformXML"
	echo "<kit ver=\"1.0\" dn=\"platform\" fn=\"Platform Definition\" model=\"""$Platform""\" os=\"""$OS""\" >" >> "$platformXML"
    	echo " <table>" >> "$platformXML"
	echo "  <p v=\"t\" e=\"f\" c=\"f\" s=\"f\" dn=\"mac\" fn=\"Unique Device ID\" dt=\"varchar(36)\"/>" >> "$platformXML"
        echo "  <p v=\"t\" e=\"f\" c=\"f\" s=\"f\" dn=\"vendor\" fn=\"Vendor Code\" dt=\"varchar(8)\"/>" >> "$platformXML"
	echo "  <p v=\"t\" e=\"f\" c=\"f\" s=\"f\" dn=\"model\" fn=\"Device Model Name\" dt=\"varchar(128)\"/>" >> "$platformXML"
        echo "  <p v=\"t\" e=\"f\" c=\"f\" s=\"f\" dn=\"macs\" fn=\"List of MAC addresses\" dt=\"varchar(128)\"/>" >> "$platformXML"
	echo "  <p v=\"t\" e=\"f\" c=\"f\" s=\"f\" dn=\"date\" fn=\"License Expire Date\" dt=\"varchar(8)\"/>" >> "$platformXML"
        echo "  <p v=\"t\" e=\"f\" c=\"f\" s=\"f\" dn=\"key\" fn=\"Device License Key\" dt=\"varchar(36)\"/>" >> "$platformXML"
    	echo " </table>" >> "$platformXML"
    	echo " <platform ver=\"1.0\">" >> "$platformXML"
	echo "  <mac val=\"\" />" >> "$platformXML"
	echo "  <vendor val=\"""$Vendor""\" />" >> "$platformXML"
	echo "  <model val=\"""$Model""\" />" >> "$platformXML"
        echo "  <macs val=\"\" />" >> "$platformXML"
        echo "  <date val=\"\" />"  >> "$platformXML"
        echo "  <key val=\"\" />"  >> "$platformXML"
    	echo " </platform>" >> "$platformXML"
	echo "</kit>" >> "$platformXML"