@echo off
REM -----------------------------------------------------------------
REM  SCRIPT  :  recovery.bat
REM  DATE    :  20071219
REM  AUTHOR  :  Sergey Klygin, ThinCCo AG
REM  E-MAIL  :  thinccodev@thincco.com
REM 
REM  PURPOSE :  Partitioning, 
REM             formating 1st partition and copying needed files,
REM             installing GRUB loader,
REM             calling main OS installation.
REM  HISTORY :
REM  20071101:  Initial release alfa version.
REM  20071207:  changed to use FDOS stick.
REM  20071212:  added loging to the device.log
REM  20071219:  structure changes: all executeble files moved to 'fdos' folder, 
REM             so from now all contents of the 'recovery' folder must be copied on the 1st partition
REM -----------------------------------------------------------------
set LOGFILE=%SRCDRV%\device.log
:start
cls
echo -------------------------------------------------------------------------------
echo This software will prepare your device and install a fresh operating system. 
echo CAUTION: This procedure will destroy all data on this device!
rem The process will be completed in two steps:
rem  1 - Partition the Flash Disk (512MB assumed)
rem    ! reboot required
rem  2 - Format partition 1 and 
rem      copy and install 'GRUB4DOS' loader
rem      copy the 'RecoveryOS' files
rem      unpack main OS files
rem    ! reboot required into local disk, 
rem    ! Make sure to switch the boot method in the BIOS
echo -------------------------------------------------------------------------------
echo.
echo Please choose:
echo    1. Partitioning...
echo    2. Formatting and loading Operating Systems
echo    3. Recovery System (update only)
echo    4. DOS command prompt
set /P ANS=Select [1,2,3,4]: 
IF %ANS% == 4 GOTO end
IF %ANS% == 3 GOTO rsys
IF %ANS% == 2 GOTO doform
IF %ANS% == 1 GOTO dofdisk
cls
GOTO start 

:dofdisk
echo Partitioning...
call loghead.bat
echo Partitioning... >> %LOGFILE%
fdisk /mbr 2
fdisk /clear 2
fdisk /pri:25 2
fdisk /pri:460 2
echo Partitioning successful >> %LOGFILE%
GOTO reboot1

:doform 
cls
echo -------------------------------------------------------------------------------
echo Formatting 1st partition!
call loghead.bat
echo Formatting 1st partition! >> %LOGFILE%
echo -------------------------------------------------------------------------------
format %SYSPART% /v:recovery /Z:seriously >> %LOGFILE%
echo Moving log file! >> %LOGFILE%
copy /Y %LOGFILE% %SYSPART%\
del %LOGFILE%
set LOGFILE=%SYSPART%\device.log
echo Log file: %LOGFILE% >> %LOGFILE%

rem Instalation GRUB4DOS: 
echo Installing GRUB...
echo Installing GRUB... >> %LOGFILE%
bootlace.com  0x81 >> %LOGFILE%
:rsys
IF %ANS% == 3 set LOGFILE=%SYSPART%\device.log
echo Copying files...
echo Copying files... >> %LOGFILE%
copy %SRCDRV%\recovery\*.* %SYSPART%\ >> %LOGFILE%
copy %SRCDRV%\*.xml %SYSPART%\ >> %LOGFILE%
IF %ANS% == 3 GOTO reboot2
copy %SYSPART%\menu.rs %SYSPART%\menu.lst >> %LOGFILE%
if exist %SRCDRV%\mkclone.sh copy %SRCDRV%\mkclone.sh %SYSPART%\ >> %LOGFILE%
if exist %SRCDRV%\mkclone.sh goto reboot2
call instos.bat
goto end

:reboot1
CLS
echo -------------------------------------------------------------------------------
echo  System will reboot now!
echo  System will reboot now! >> %LOGFILE%
echo -------------------------------------------------------------------------------
waitf -n2 > nul
batchman beep 1000,2
reboot
:reboot2
CLS
echo -------------------------------------------------------------------------------
echo Recovery System installed successfully!
echo Recovery System installed successfully! >> %LOGFILE%
echo -------------------------------------------------------------------------------
echo        Please switch the boot method in the BIOS to HDD-0 during reboot      
echo                        and remove the installation USB stick                 
echo                    Now press Ctrl-Alt-Del, to reboot your system             
echo -------------------------------------------------------------------------------
waitf -n1 > nul
batchman beep 1000,2
batchman beep 800,4
waitf -n3000 > nul
:end
