@echo off
REM -----------------------------------------------------------------
REM  SCRIPT  :  instlx.bat
REM  DATE    :  20071219
REM  AUTHOR  :  Sergey Klygin, ThinCCo AG
REM  E-MAIL  :  thinccodev@thincco.com
REM 
REM  PURPOSE :  Installing FreeDOS on the 1st partition, 
REM             formating 2st partition and unpacking system files,
REM  HISTORY :
REM  20071101:  Initial release alfa version.
REM  20071127:  Added header and Linux default settings saving.
REM  20071127:  RM: OSIMAGE changed to LXFAM01
REM  20071207:  changed to use FDOS stick.
REM  20071212:  added loging to the device.log
REM  20071213:  some logging improvements + pause if pkunzip failed
REM  20071219:  corrected error checking on pkunzip
REM  20080403:  long file names support added;
REM  20080410:  some corrections to support safeboot;
REM  20080411:  added support of long file names in startos.bat;
REM -----------------------------------------------------------------
rem Edit this file to instal some Linux build

:start
cls
echo.
echo Please choose WinCE image:
echo    1. CECLE01
echo    2. CECLE02
echo    3. CEPLE01
echo    4. CEAMD01 for T5117F
echo    5. DOS command prompt
echo    6. Reboot
set /P ANS=Select [1,2,3,4,5,6]:
IF %ANS% == 6 reboot
IF %ANS% == 5 set ANS=-1
IF %ANS% == 4 GOTO ceamd
IF %ANS% == 3 GOTO ceple01
IF %ANS% == 2 GOTO cecle
IF %ANS% == 1 GOTO cecle
IF %ANS% == -1 GOTO end
GOTO start 

:cecle
set OSIMAGE=os\CECLE0%ANS%.zip
GOTO install

:ceple01
set OSIMAGE=os\CEPLE01.zip
GOTO install

:ceamd
set OSIMAGE=os\CEAMD01.zip
fdisk /mbr 2
GOTO install

:install
echo. >> %LOGFILE%
echo Installing %OSIMAGE% >> %LOGFILE%
cd %SRCDRV%\fdos
sys %SYSPART% >> %LOGFILE%

echo Copying files...
echo Copying files... >> %LOGFILE%
copy /Y fdconfig.sys %SYSPART%\ >> %LOGFILE%
copy /Y autoexec.bat %SYSPART%\ >> %LOGFILE%
copy /Y CADEL.COM    %SYSPART%\ >> %LOGFILE%
copy /Y HIMEM.EXE    %SYSPART%\ >> %LOGFILE%
copy /Y WAITF.EXE    %SYSPART%\ >> %LOGFILE%
copy /Y BATCHMAN.COM %SYSPART%\ >> %LOGFILE%
copy /Y DOSLFN.COM   %SYSPART%\ >> %LOGFILE%
copy /Y CP437UNI.TBL %SYSPART%\ >> %LOGFILE%
copy /Y MOVE.EXE     %SYSPART%\ >> %LOGFILE%
copy /Y blackout\*.* %SYSPART%\ >> %LOGFILE%

cd \

echo Formatting 2nd partition!
echo Formatting 2nd partition! >> %LOGFILE%
format %OSPART% /v:system /Z:seriously >> %LOGFILE%
%OSPART% 
doslfn
echo Unpacking WinCE image...
echo Unpacking WinCE image... >> %LOGFILE%
if not exist %SRCDRV%\%OSIMAGE% goto error1
pkunzip %SRCDRV%\%OSIMAGE% -d >> %LOGFILE%
:menu
copy /Y %SRCDRV%\recovery\menu.ce %SYSPART%\ >> %LOGFILE%
copy /Y %SYSPART%\menu.ce %SYSPART%\menu.lst >> %LOGFILE%
CLS
echo -------------------------------------------------------------------------------
echo WinCE installation completed!
echo WinCE installation completed! >> %LOGFILE%
goto end
:error1
echo %SRCDRV%\%OSIMAGE% not found!
pause
goto menu
:error2
echo Some error(%errorlevel%) occured while unpaking image!
pause
goto menu
:end