@echo off
REM -----------------------------------------------------------------
REM  SCRIPT  :  instlx.bat
REM  DATE    :  20071219
REM  AUTHOR  :  Sergey Klygin, ThinCCo AG
REM  E-MAIL  :  thinccodev@thincco.com
REM 
REM  PURPOSE :  Installing FreeDOS on the 1st partition, 
REM             formating 2st partition and unpacking system files,
REM  HISTORY :
REM  20071101:  Initial release alfa version.
REM  20071127:  Added header and Linux default settings saving.
REM  20071127:  RM: OSIMAGE changed to LXFAM01
REM  20071207:  changed to use FDOS stick.
REM  20071212:  added loging to the device.log
REM  20071213:  some logging improvements + pause if pkunzip failed
REM  20071219:  corrected error checking on pkunzip
REM  20080123:  removed FreeDOS from 1st partition;
REM -----------------------------------------------------------------
rem Edit this file to instal some Linux build

set OSIMAGE=os\LXFAM01.zip
echo. >> %LOGFILE%
echo Installing %OSIMAGE% >> %LOGFILE%

echo Formatting 2nd partition!
echo Formatting 2nd partition! >> %LOGFILE%
format %OSPART% /v:system /Z:seriously >> %LOGFILE%
copy %SRCDRV%\recovery\menu.lx %SYSPART%\ >> %LOGFILE%
copy /Y %SYSPART%\menu.lx %SYSPART%\menu.lst >> %LOGFILE%
%OSPART% 
doslfn
echo Unpacking Linux image...
echo Unpacking Linux image... >> %LOGFILE%
if not exist %SRCDRV%\%OSIMAGE% goto error1
pkunzip %SRCDRV%\%OSIMAGE% -d >> %LOGFILE%
:menu
rem copy /Y %SRCDRV%\fdos\grub.exe %OSPART%\ >> %LOGFILE%
copy tc.cfg fd.cfg >> %LOGFILE%
del %OSPART%\menu.lst >> %LOGFILE%
CLS
echo -------------------------------------------------------------------------------
echo Linux installation completed!
echo Linux installation comtleted! >> %LOGFILE%
goto end
:error1
echo %SRCDRV%\%OSIMAGE% not found!
pause
goto menu
:error2
echo Some error(%errorlevel%) occured while unpaking image!
pause
goto menu
:end