@echo off
REM -----------------------------------------------------------------
REM  SCRIPT  :  instxp.bat
REM  DATE    :  20071219
REM  AUTHOR  :  Sergey Klygin, ThinCCo AG
REM  E-MAIL  :  thinccodev@thincco.com
REM 
REM  PURPOSE :  Installing XP OS on the 2nd partition
REM             formating 2st partition and unpacking system files,
REM  HISTORY :
REM  20071031:  Initial release alfa version.
REM  20071203:  RM: Added header and.
REM  20071203:  RM: exetend to have n as parameter for OSIMAGE XPFAMnn
REM  20071207:  removed extention, added image choose menu
REM  20071207:  changed to use FDOS stick.
REM  20071212:  added loging to the device.log
REM  20071213:  some logging improvements + pause if pkunzip failed
REM  20071219:  corrected error checking on pkunzip
REM -----------------------------------------------------------------
Rem Edit this file to instal some WinXPe build
:start
cls
echo.
echo Please choose WinXPe image:
echo    1. XPFAM01
echo    2. XPFAM02
echo    3. XPFAM03
echo    4. XPFAM02 for T5117F
echo    5. 3rd party WinXPe image
echo    6. DOS command prompt
set /P ANS=Select [1,2,3,4,5,6]:
IF %ANS% == 6 set ANS=-1
IF %ANS% == 5 GOTO menu
IF %ANS% == 4 GOTO winxpeamd
IF %ANS% == 3 GOTO winxpe
IF %ANS% == 2 GOTO winxpe
IF %ANS% == 1 GOTO winxpe
IF %ANS% == -1 GOTO end
GOTO start 

:winxpeamd
fdisk /mbr 2
set ANS=2

:winxpe
set OSIMAGE=os\XPFAM0%ANS%.zip
echo. >> %LOGFILE%
echo Installing %OSIMAGE% >> %LOGFILE%

echo Formatting 2nd partition!
echo Formatting 2nd partition! >> %LOGFILE%
format %OSPART% /v:system /Z:seriously >> %LOGFILE%
%OSPART% 
doslfn
echo Unpacking WinXPe image...
echo Unpacking WinXPe image... >> %LOGFILE%
if not exist %SRCDRV%\%OSIMAGE% goto error1
pkunzip %SRCDRV%\%OSIMAGE% -d >> %LOGFILE%
:menu
copy %SRCDRV%\recovery\menu.xp %SYSPART%\ >> %LOGFILE%
copy /Y %SYSPART%\menu.xp %SYSPART%\menu.lst >> %LOGFILE%
IF %ANS% == 5 GOTO end1
CLS
echo -------------------------------------------------------------------------------
echo WinXPe installation completed!
echo WinXPe installation completed! >> %LOGFILE%
goto end
:end1
CLS
echo -------------------------------------------------------------------------------
echo Device ready for 3rd party WinXPe image installation!
echo Device ready for 3rd party WinXPe image installation! >> %LOGFILE%
goto end
:error1
echo %SRCDRV%\%OSIMAGE% not found!
pause
goto menu
:error2
echo Some error(%errorlevel%) occured while unpaking image!
pause
goto menu
:end